Redmine - Feature #2850
Add next/previous navigation to issue
2009-02-26 21:58 - Christian Zagrodnick

Status: Closed Start date: 2009-02-26
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 1.4.0

Resolution: Fixed

Description

When opening an issue from an issue list there should be next/previous links on the ticket to navigate the list.

Related issues:

Duplicated by Redmine - Feature # 3337: Button Next/Previous on issue form Closed 2009-05-11
Duplicated by Redmine - Feature # 4028: Ability to navigate to next and previ... Closed 2009-10-14
Duplicated by Redmine - Feature # 4583: Add the ability to navigate in issues Closed 2010-01-14
Duplicated by Redmine - Feature # 5361: Next / previous issue feature Closed 2010-04-21
Duplicated by Redmine - Feature # 7030: link issue which belong to the same c... Closed 2010-12-03
Duplicated by Redmine - Feature # 7050: Navigation bar for faster issues han... Closed 2010-12-05
Duplicated by Redmine - Feature # 7323: Previous/Next issue breadcrumbs Closed 2011-01-13
Duplicated by Redmine - Feature # 976: add button Closed 2008-04-02

Associated revisions

Revision 8488 - 2012-01-03 21:09 - Jean-Philippe Lang

Adds previous/next links to issue (#2850).

Revision 8493 - 2012-01-04 06:50 - Toshi MARUYAMA

use i18n label for previous and next issue (#2850)

History

#1 - 2009-02-26 22:21 - Mischa The Evil

Just my first thoughts on this FR:

Christian Zagrodnick wrote:

...there should be next/previous links on the ticket to navigate the list.

This could become a bit difficult and can lead to some confusion considering the fact that this could be understood as:

1. The next issue in the list (as in: #2 is the next behind #1)

2. The next issue in the list (as in: #10# is the next behind #1 respecting the current issue-query (filters) state)

What do you think?

#2 - 2009-02-27 08:10 - Christian Zagrodnick
The second is what | was thinking about.
Actually I'm a long time Bugzilla user, so | may be a little biased. Let me describe what's happening there as | find this quite handy:

- When you do a search and open a ticket from this search, you'll get those first/next/prev/last links.

- There is also a link "show list" which takes you back to the list.

- The list stays stable. That is that the search tickets h is only done once and Bugzilla stores the ticket ids for the list. This is probably the major
trick because it really avoids confusion: say you list your open and fix a few. Going back to the list shows the fixed as fixed although the initial search
filters for open onces.

Another thing is that when updating a ticket Bugzilla it doesn't display the updated ticket but the next one in the list.

Just my two cents :)

#3 - 2009-02-27 09:08 - Jens Goldhammer

Sounds really good. Trac does the same...

As you both mentioned, there are different contexts:

1. If you browse the tickets without a search-> it should provide you a next and previous button for browsing to the ticket one number after the current
or one before the current.

2. If you make a search or work in a custom report, the links should take you through the list as described by Christian.

| would like to see both things implemented! To make the difference understandable by the users, there should be good button labels ("next ticket" for
normal browsing, "next ticket in search" for searching) and maybe tooltips.

Thanks,

Jens

#4 - 2009-02-27 16:06 - Christian Zagrodnick

Jens Goldhammer wrote:

1. If you browse the tickets without a search-> it should provide you a next and previous button for browsing to the ticket one number after the

current or one before the current.

Frankly, | don't see a use in that. Ticket numbers are basically random in regard to the ticket contents. Subsequent numbers usualy relate to totally

unrelated tickets. Why would one want to navigate that?

| think when you navigate to a ticket without having a search (or if the ticket is not in the search list) those links should just be disabled until you get to a

ticket which is in the list again.

#5 - 2009-02-27 21:36 - Enderson Maia

Christian Zagrodnick wrote:

Frankly, | don't see a use in that. Ticket numbers are basically random in regard to the ticket contents. Subsequent numbers usualy relate to totally

unrelated tickets. Why would one want to navigate that?
| agree. This ticket navbar just should be shown when you are in a filter/report result.

#6 - 2009-06-18 19:39 - Tom Burke

+1 to this ticket.

| don't agree with Christian and Enderson's recent conversation about this not being useful. I've wanted this feature for a while because often as I'm
creating new tickets, related tickets end up adjacent to one another in the project's list. Then later, when updating or closing, it would be useful to

navigate to the next one, recalling that they fell next to each other.

| agree with the above that search context should be retained. And | like the stipulation that if the user closes a ticket, it still appears when he scrolls
through his search results via next/previous, even if it was open when he searched for it.

Here's how | view the details of this feature:

By default, the First button navigates to the ticket whose ID is numerically the smallest, WITHIN THE PROJECT CURRENTLY BEING VIEWED.
By default, the Last button navigates to the ticket whose ID is numerically the greatest, WITHIN THE PROJECT CURRENTLY BEING VIEWED.
By default, the Next button navigates to the next greatest ID WITHIN THE CURRENT PROJECT.

By default, the Previous button navigates to the next least ID WITHIN THE CURRENT PROJECT.

Several navigational scopes should be identified, to determine how Next/Previous/First/Last will behave:

- A "default" scope, where the user is navigating among all open tickets. This is the state reached when clicking on "Issues" for the first time.
- A "search" scope, where the user is navigating among tickets resulting from his last search.

- A "filter" scope, where the user is navigating among tickets resulting from his last filter via the Issues screen.

- An "all" scope, where the user is navigating among all tickets throughout the system.

The search scope should be retained even if ticket statuses change, e.g., from open to Closed (see Christian's suggestion above:)
The list stays stable. That is that the search tickets h is only done once and Bugzilla stores the ticket ids for the list. This is probably the major trick

because it really avoids confusion: say you list your open and fix a few. Going back to the list shows the fixed as fixed although the initial search
filters for open onces.

#7 - 2009-06-30 05:11 - Cyber Sprocket

+1

This would be a great feature. I've been wanting a "next issue" button since the 2nd day we've been on Redmine. It is very useful as a project
manager to go through and bump dates, re-assign people,or change priorites as the issues for new projects/features tend to fall next to each other on
the list.

Even more useful if it goes from the list you were looking at including any filters that were set.

#8 - 2009-09-10 16:12 - Philippe Lafoucriére

+11

#9 - 2009-09-10 21:16 - Nanda P

+1
#10 - 2010-01-12 22:38 - Alex Last

+1.

btw, can we have "votes" to avoid adding this stupid "+1"?

#11 - 2010-02-20 21:48 - Eric Wasylishen

+1.

It would make reading through a list of issues a lot easier.

#12 - 2010-03-08 15:56 - Alexander Stehlik

+1

#13 - 2010-03-31 20:33 - Christian Hausleitner

+1

#14 - 2010-04-21 19:56 - Aron Rotteveel

+1

#15 - 2010-04-21 21:44 - minkbear minkbear

+1

#16 - 2010-04-23 19:15 - Andrew Sherman

+1

At my business we recently moved from Bugzilla to Redmine and the #1 questions | get from everyone is "there a next/prev link when you are going

through your issues?"

#17 - 2010-05-11 22:56 - Kioma Aldecoa

+1 we also are moving from bugzilla, and the one thing everybody misses is the next/prev links

#18 - 2010-05-21 13:12 - lvo Abadjiev

+ 1 we moved from JIRA and all the team is missing this feature

#19 - 2010-06-21 22:22 - David Parker

+1
#20 - 2010-07-02 00:31 - Eric Peterson

+1

#21 - 2010-07-02 05:01 - xt zhang

+1

#22 - 2010-10-08 21:51 - Jean-Jacques Mérillon

+1

#23 - 2010-11-16 19:58 - John Bart

+1

#24 - 2010-12-05 09:17 - Emidio Stani

+1

#25 - 2011-01-13 19:13 - loic Le Gallou

+1

#26 - 2011-02-01 12:40 - lan Medland

+1

#27 - 2011-04-13 11:27 - Sam Garnham

+1

#28 - 2011-04-13 11:52 - Albert M

+1

#29 - 2011-04-18 09:29 - Anton Lukashev

+1

#30 - 2011-07-19 12:10 - Andrea Colleoni
+1

#31 - 2011-07-20 10:32 - Andrew Lansdowne
+1 this is a real issue for me moving from JIRA, | really don't mind how it is implemented (whether it updates the list when issues are amended or

whether the list is static from your results) but just having to go back using the browser between viewing each issue just doubles the amount of
clicking/waiting when you are trying to look through your issues.

#32 - 2011-07-20 10:53 - Etienne Massip

- Target version set to Candidate for next major release
#33 - 2012-01-03 11:24 - Marcel Ritter

+1

#34 - 2012-01-03 21:22 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version changed from Candidate for next major release to 1.4.0
- Resolution set to Fixed

Feature added in r8488 in its simplest form. The links show the previous and next issues as listed on the issue list without storing the query results.

#35 - 2012-03-01 22:33 - Maciej Maczynski

| applied changes from r8488 over 1.3.0 installation (installed from tarball) hoping it would be enough to change only files mentioned in this release.
Looks it is not: | have the following error in log when clicking on issue from the list:

Rendering /var/www/redmine/public/500.html (500 Internal Server Error)

Processing IssuesController#show (for 192.168.115.8 at 2012-03-01 22:05:22) [GET]

Parameters: {"action"=>"show", "id"=>"24", "controller"=>"issues"}
NoMethodError (undefined method “issue_ids' for #<Query:0xb560f1d4>):

app/controllers/issues_controller.rb:289:in “retrieve_previous_and_next_issue_ids'
app/controllers/issues_controller.rb:124:in “show'

The issue is not mentioned in 1.3.1 Changelog, so it is not included there, right?
Is there some kind of minimal-manual-changes to make it work with 1.3.0?

#36 - 2012-03-02 08:54 - Etienne Massip

See r8487.
#37 - 2012-03-02 22:39 - Maciej Maczynski

Yes you're right - it was necessary. But one more change was needed:
In r8488, show.html.erb line 42 is:
<td class="spent-time"><%= @issue.total_spent_hours > 0 ? (link_to |_hours(@issue.total_spent_hours), {:controller => 'timelog', :action =>

'index’, :project_id => @project, :issue_id => @issue}) : "-" %o></td>
| changed it to original 1.3.0 version (not using "total_spent_hours":
<td class="spent-time"><%= @issue.total_spent_hours > 0 ? (link_to |_hours(@issue.total_spent_hours), {:controller => 'timelog', :action =>

'index’, :project_id => @project, :issue_id => @issue}) : "-" %o></td>

Now it works!!! Thanks a lot for your help. After ten years using Bugzilla | missed this functionality VERY much.

#38 - 2012-03-21 11:35 - Sanjay Kashalkar

After adding r8487 and r8488 onto Redmine 1.3.2.stable.6570 | can see the next/prev navigation links. However, deleting an issue fails with the

following error.

Processing IssuesController#destroy (for 172.23.41.54 at 2012-03-21 11:28:34) [POST)]
Parameters: {"back_url"=>"/redmine/projects/opl/issues", "ids"=>["5589"], "action"=>"destroy",

"authenticity _token"=>"0Oe6ubDyrsKmGc7wRP6Qofw3XjpuUJwTTcWG5am5TF94=", "controller"=>"issues"}
Filter chain halted as [#<Proc:0x05646a98@C:/Program Files/BitNami Redmine
Stack/ruby/lib/ruby/gems/1.8/gems/actionpack-2.3.14/lib/action_controller/verification.rb:82>] rendered_or_redirected.
Completed in 68ms (View: 6, DB: 31) | 405 Method Not Allowed
[http://abcdef/redmine/issues/destroy?back_url=%2Fredmine%2Fprojects%2Fopl%2Fissues&ids%5B%5D=5589]

Any ideas why?

To reproduce simply select one or more issues and right click 'delete’.

#39 - 2012-03-21 11:45 - Maciej Maczynski

| have exactly same problem: after applying those changes | cannot delete issues any more.
| did not report it so far as | had no time to verify 100% if this is really caused by this change or maybe some plug-in I've installed.

But your post seems to confirm that the problem is related revisions mentioned hare: | also have this "Method Not Allowed" error now.

#40 - 2012-03-23 12:10 - Maciej Maczynski

Solved: you have to apply changes from r8150.
